
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>诊断Java代码: Impostor Type错误模式 / iVAN</title>

    <meta name="description" content="诊断Java代码: Impostor Type错误模式 当使用字段中特殊的标记来区别对象类型时,可能会产生标记对相关数据误贴标签的错误 ― 通称为 Impostor Type 错误模式.在诊断 Java 代码的这一部分中,Eric Allen 对这个错误的症状和起因进行了分析,详细说明了预防错误发生的方法,并讨论了一种吸引人的混合实现方法,这种方法不使用 impostor type,但最后,还是有很多相同的缺点产生.请在 讨论论坛与作者及其他读者分享您对本文的看法. 程序中除了最无关紧要的部分外都要对某些数据类型进行操作.静态类型系统提供了一种方法,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">诊断Java代码: Impostor Type错误模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>当使用字段中特殊的标记来区别对象类型时，可能会产生标记对相关数据误贴标签的错误 ― 通称为 Impostor Type 错误模式。在诊断 Java 代码的这一部分中，Eric Allen 对这个错误的症状和起因进行了分析，详细说明了预防错误发生的方法，并讨论了一种吸引人的混合实现方法，这种方法不使用 impostor type，但最后，还是有很多相同的缺点产生。请在 讨论论坛与作者及其他读者分享您对本文的看法。</p>
<p>程序中除了最无关紧要的部分外都要对某些数据类型进行操作。静态类型系统提供了一种方法，它能够确保程序不会对给定类型的数据进行不当的操作。Java 语言的优点之一是严格的区分类型，所以在程序运行前已消除了类型错误。作为开发人员，我们可以使用这个类型系统提供更健壮且没有错误的代码。然而，我们却常常没有让类型系统发挥出最大的潜力。</p>
<p>Impostor Type 错误模式</p>
<p>很多程序可以更多地使用静态类型系统，但它们没有这样做，而是依赖包含区别数据类型标记的特殊字段。</p>
<p>依靠这些特殊字段区别数据类型，这样的程序放弃了类型系统专门提供给它们的保护措施。当这些标记中的一个对它的数据误贴了标签，就会产生我称之为 Impostor Type的错误。</p>
<p>症状</p>
<p>impostor type 错误的一种常见症状是很多概念上不同类型的数据都被同样（并且错误）的方式处理。另一常见症状是数据与任何指定的类型都不匹配。</p>
<p>首要规则是，只要当概念上的数据类型和它被程序处理的方法不匹配，就可以怀疑是否发生了这个模式的错误。</p>
<p>为说明引入这种模式的错误是多么的轻而易举，让我们来考虑一个简单的示例。假设我们需要处理各种各样的欧几里得几何学形状，如圆形、正方形等等。这些几何形状没有坐标，但含有一个 scale 变量，所以可以计算它们的面积。</p>
<p>清单 1. 用 imposter type 实现各种几何形状</p>
<p><code>public class Form {<br />
　　 String shape;<br />
　　 double scale;<br />
　　 public Form(String _shape, double _scale) {<br />
　　　　 this.shape = _shape;<br />
　　　　 this.scale = _scale;<br />
　　 }<br />
　　 public double getArea() {<br />
　　　　 if (shape.equals("square")) {<br />
　　　　　　 return scale * scale;<br />
　　　　 }<br />
　　　　 else if (shape.equals("circle")) {<br />
　　　　　　 return Math.PI * scale * scale;<br />
　　　　 }<br />
　　　　 else { // shape.equals("triangle"), an equilateral triangle<br />
　　　　　　 return scale * (scale * Math.sqrt(3) / 4);<br />
　　　　 }<br />
　　 }<br />
}</code></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 23:57:41</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%94%99%e8%af%af/" title="错误">错误</a>, <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f/" title="程序">程序</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%b1%bb%e5%9e%8b/" title="数据类型">数据类型</a>, <a href="https://www.iamivan.net/tag/%e7%b1%bb%e5%9e%8b/" title="类型">类型</a>, <a href="https://www.iamivan.net/tag/shape/" title="shape">shape</a>, <a href="https://www.iamivan.net/tag/scale/" title="scale">scale</a>, <a href="https://www.iamivan.net/tag/%e9%94%99%e8%af%af%e7%b1%bb%e5%9e%8b/" title="错误类型">错误类型</a>, <a href="https://www.iamivan.net/tag/%e7%b1%bb%e5%9e%8b%e9%94%99%e8%af%af/" title="类型错误">类型错误</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>诊断Java代码: Impostor Type错误模式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRy32Gb.html" rel="bookmark">诊断Java代码&colon; 臆想实现错误模式，第2部分</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				臆想实现重温 回想一下 上次接口的 臆想实现是一个合法的实现,但不满足接口规范的某些未经检查的方面.我们考虑一下下面的堆栈接口,以及许多未被其单独的类型签名捕获的不变量: 清单 1. 一个堆栈接 public interface Stack { public Object pop(); public void push(Object top); public boolean isEmpty(); } 例如,请考虑我们希望任意堆栈实现都遵守的下列规则: 如果一个对象 o 被压进堆栈 s ,且在堆栈			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo69N6z.html" rel="bookmark">诊断Java代码&colon; Broken Dispatch错误模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				整体和部分 还记得这条谚语吗,&quot;整体大于部分之和&quot;?如果把一个个独立的事件组合成一个相互作用的整体,产生的结果会比单个个体的作用之和要大得多. 程序也是一样的道理.随着一个个新方法被添加到程序中,整个程序可能的控制流程迅速增加.对于大型程序而言,很快局面就会无法控制了.就象是一个荒谬而又不可思议的戏法,有时您得到的最终结果并不是您所期望的方向 ― 这同您在重载方法或者覆盖方法时遇到的情况有些类似. Broken Dispatch 错误模式 面向对象语言的最强大的特性之一就是继承多态性.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4W37p.html" rel="bookmark">诊断Java代码&colon; Double Descent错误模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不要强制转换这个类! 与可怕的 空指针异常(该异常除了报告空指针之外,对于将要发生的事情什么也不说)不同,类强制转换异常相对来说容易调试. 类强制转换经常发生在递归下行数据结构的程序中,通常是当代码的某些部分在每次方法调用中下行了两级且在第二次下行时调度不当时发生的.程序员可通过学习 Double Descent 错误模式来识别这种问题. Double Descent 错误模式 本周的专题是 Double Descent 错误模式.它通过类强制转换异常来表明.它是由递归下行复合数据结构引起的,这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxPwq0M.html" rel="bookmark">诊断Java代码&colon; Liar View错误模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Liar, liar! 设想一下:您已经为一个分布式系统精心设计了一个极好的 GUI 程序,它包含了客户机请求的所有东西及其它一些东西.您已经让它运行通过了一个自动化测试套件的测试 ― 由于不变量的数量是个天文数字,因此,自动化测试是必须的.测试的结果是程序获得了一张&quot;无错误的健康证明书&quot;. 发布这个 GUI 的期限到了,但是,作为一个象您这样严格的程序员,只是为了发现错误的行为 ― 本该在自动化测试中就被捕捉到的行为,您启动了程序,对它做最后一次手工测试.但愿您能够避免这种情形.真的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1Rv5jp.html" rel="bookmark">诊断Java代码&colon; 空标志错误模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				空标志错误模式 在我的上一篇文章中,我说明了用空指针代替各种不同基本类型的数据是如何成为引起 NullPointerException 异常最普遍的原因之一的.这一次,我将说明用空指针代替异常情况怎么也会导致问题的出现.在 Java 程序中,异常情况通常是通过抛出异常,并在适当的控制点捕获它们来进行处理.但是经常看到的方法是通过返回一个空指针值来表明这种情况(以及,可能打印一条消息到 System.err ).如果调用方法没有明确地检查空指针,它可能会尝试丢弃返回值并触发一个空指针异常. 您可能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Myr9x4p.html" rel="bookmark">诊断Java代码&colon; Fictitious Implementation错误模式，第1部分</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 语言接口是一种强大的工具.它具有多继承的很多优点,而没有什么问题.为客户希望使用的所有服务指定一个接口,使得在需要时插进这种接口的不同实现成为可能. 遗憾的是,规范中可以被表达的部分只有方法说明.对任何实现来说,很可能还有很多其它不变量希望被掌握,但是 Java 语言没有提供检查它们的工具. 臆想错误模式 由于这种限制,很可能&quot;实现&quot;了一个接口而实际上没有满足预期的语义.由这种 Fictitious Implementation导致的错误就是本周专栏的主题. 例如,请看一看下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YMRWGpm.html" rel="bookmark">诊断Java代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				诊断Java代码: Broken Dispatch错误模式 诊断Java代码: Double Descent错误模式 诊断Java代码: Impostor Type错误模式 诊断Java代码: Java编程中的断言和时态逻辑 诊断Java代码: Liar View错误模式 诊断Java代码: Repl提供交互式评价 诊断Java代码: 单元测试与自动化代码分析协同工作 诊断Java代码: 将时态逻辑用于错误模式 诊断Java代码: 进行记录器测试以正确调用方法 诊断Java代码: 空标志错误模式			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4WE7p.html" rel="bookmark">诊断Java代码：孤线程（Orphaned Thread）错误模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在多线程代码中,使用驱动其它线程所负责的动作的单个主线程是常见的.这个主线程发送消息,通常是通过把它们放到一个队列中,然后其它线程处理这些消息.但是如果主线程抛出一个异常,那么剩余的线程会继续运行,等待更多输入到该队列,导致程序冻结.在诊断 Java 代码的这一部分中,专职 Java 开发者兼兼职捉虫者 Eric Allen 讨论检测.修复和避免这一错误模式. 用多线程编写代码对程序员大有好处.多线程能使编程(和程序)进行得快得多,而且代码能有效得多地使用资源.然而,跟生活中的很多事情一样,多线			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Nz77qzW.html" rel="bookmark">诊断Java代码&colon; 进行记录器测试以正确调用方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用 JUnit进行单元测试是一个功能强大的方法,它可以确保您的代码基础的完整性,但是一些不变量比其他(方法调用序列是其中一种)更难测试.在诊断Java 代码这一部分,Eric Allen描述了怎样在您的单元测试中使用记录器(一种特殊的侦听器),来确保一个方法调用序列按恰当的顺序发生.请点击文章顶部和底部的 讨论,与作者和其他读者在论坛上分享您关于本文的看法. 随着时间的推移,当系统开发人员,维护人员甚至是系统详细说明改变时,JUnit 框架提供一个很好的方法来改善系统的坚固性.通过测试,您可以检			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyeRPM.html" rel="bookmark" class="title">jdk中cocurrent下的AbstractQueuedSynchronizer理解记录</a>
					<div>
						 以前虽然看过一次AQS的源码实现,但在过一段时间后与同学交流时,发觉自己理解并不够深,印像太浅.需要做一个记录整理,帮助自己消化.   AQS中Node的设计:    几个点: 1. Node实现作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR1jeb.html" rel="bookmark" class="title">你会设计表单吗？网页表单结构设计</a>
					<div>
						网页制作Webjx文章简介:Web表单设计:表单结构. 你是否曾为表单设计感到过沮丧或不知所措呢?接下来三篇文章,希望能彻底改变你的看法,真正爱上Web表单设计.首先感谢Luke Wroblewski ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOQ9qM.html" rel="bookmark" class="title">用EasyMailObject组件处理Exchange邮件源代码&lpar;1&rpar;</a>
					<div>
						在ASP中用EasyMailObject组件处理Exchange邮件源代码---读取邮件主题和大小(maillist1.asp) &lt;%@ LANGUAGE=&quot;VBSCRIPT&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBwNQb.html" rel="bookmark" class="title">在线存储数据压缩技术的缺陷</a>
					<div>
						之前我们已经介绍过主存储重复数据删除技术的益处,以及主要供应商产品对比.但是任何技术都是双刃剑,用户在实施之前还是应该综合考虑,周密部署,取其长避其短.本文主要介绍了主存储数据精 简的几个缺点. 本文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNB4Db.html" rel="bookmark" class="title">Windows 2008系统菜单的简单设置方法</a>
					<div>
						相信许多人在与Windows Server 2008系统进行过一次&quot;零距离&quot;接触之后,都会对它的许多功能心动不已.这 不,在普通操作系统下看似十分平常的系统菜单或右键菜单,在Win ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOZy5b.html" rel="bookmark" class="title">Photoshop合成深草中闻着花香的女孩</a>
					<div>
						  Photoshop合成深草中闻着花香的女孩           最终效果 1.首先打开美女图片. 2.用钢笔抠出拖入背景图片中,头发部分我们后期处理. 3.载入草丛笔刷,把颜色动态和传递去掉勾选, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PkQ6M.html" rel="bookmark" class="title">linux常用命令APT命令参数</a>
					<div>
						  apt-cache search package 搜索包 apt-cache show package 获取包的相关信息,如说明.大小.版本等 sudo apt-get install packa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwoNlb.html" rel="bookmark" class="title">有道云笔记冲突笔记是什么？</a>
					<div>
						  原因:冲突笔记一般发生在多平台操作的情况下.比如您在PC客户端上打开了笔记A并进行编辑,在没有同步的情况下又在手机上再次打开笔记A进行编辑.之后两个端分别同步,就会出现冲突笔记. 解决办法:请您核 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z427mLM.html" rel="bookmark" class="title">pagefile&period;sys文件如何移动</a>
					<div>
						  理所当然,既然pagefile.sys可以删除,可以设置大小,当然也可以移动了.移动方法和本文中删除pagefile.sys文件的方法有些类似,都在是 系统&gt;高级&gt;设置&gt;性能选项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkrdab.html" rel="bookmark" class="title">WinPE系统修改方法</a>
					<div>
						  如果你是PE高手,当然可以自己制作WinPE系统,但大多数系统爱好者不具备这样的能力,因此我们完全可以借助网上优秀的WinPE资源进行整合,打造属于自己的WinPE系统.现在就以深度WinPE v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24GLvp.html" rel="bookmark" class="title">ios-NSDate获取当前年份是不是闰年</a>
					<div>
						问题描述 NSDate获取当前年份是不是闰年 在NSDate中获取当前年份,如何判断是不是闰年? 是不是可以通过计算天数判断? 谢谢 解决方案 +(BOOL)bissextile:(int)year  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6Z12b.html" rel="bookmark" class="title">请教Android布局管理器简单问题：&commat;&plus;id&sol;ok</a>
					<div>
						问题描述 在代码中看到使用 setContentView或者findViewById,这些方法的输入参数都是int型数字,如:Button btn = (Button)findViewById(R.i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjm430z.html" rel="bookmark" class="title">laravel吐槽系列之一</a>
					<div>
						最近项目中经常使用到了laravel框架,对于这个框架之前只是弱弱地接触了一点,没有深入接触,这下有时间好好研究它了(主要是不得不研究了).说实话,laravel让我打开眼界了,之前对框架的使用一直停 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjGW5b.html" rel="bookmark" class="title">北京市工商局出台住宅楼作为住所办理登记注册的规定</a>
					<div>
						市工商局出台住宅楼作为住所办理登记注册的规定 为贯彻落实国家工商总局&lt;关于住所(经营场所)登记有关问题的通知&gt;(工商企字[2007]236号),以及北京市人民政府办公厅&lt;关于进一步加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvrr71M.html" rel="bookmark" class="title">框架-play framework 错误 检查</a>
					<div>
						问题描述 play framework 错误 检查 我就是想 找到play framework 死掉 或者报错的时候能即时通知 例如在资源不够的情况下 但是 不知道怎么检查出来					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEJe6z.html" rel="bookmark" class="title">Office 2016七月更新：Word和Outlook更智能，PowerPoint新动效</a>
					<div>
						微软本月推出了新的Office软件的更新,Word和Outlook都有加入智能功能,Word新增加了可靠信息查询Researcher和智能纠错文字优化功能Editor,Outlook也将移动端的Foc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6jxnM.html" rel="bookmark" class="title">动态规划-一个比较麻烦的任务调度问题</a>
					<div>
						问题描述 一个比较麻烦的任务调度问题 先上题: 问题描述 有若干个任务需要在一台机器上运行.它们之间没有依赖关系,因此 可以被按照任意顺序执行. 该机器有两个 CPU 和一个 GPU.对于每个任务,你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQWW8z.html" rel="bookmark" class="title">简易使用UILabel的富文本</a>
					<div>
						简易使用UILabel的富文本   使用效果: 源码: NSString+YX.h    NSString+YX.m // // NSString+YX.h // YXKit // // Copyri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pvyrp.html" rel="bookmark" class="title">constraint-SQL：在check约束中使用Case函数</a>
					<div>
						问题描述 SQL:在check约束中使用Case函数 公司A,这个公司有个规定,女职员的工资必须高于1000块.如果用Check和Case来表现的话,如下所示:CONSTRAINT check__sa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ry5Nz.html" rel="bookmark" class="title">&period;net-关于cad二次开发编辑cuix的问题</a>
					<div>
						问题描述 关于cad二次开发编辑cuix的问题 2C 网上的资料挺少的.我需要通过.net编辑cuix文件给AutoCAD2010增加几个toolbarbutton,思路是这样的:将cuix后缀改为z ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAqYeM.html" rel="bookmark" class="title">维基解密仍未提供CIA黑客工具 之前承诺或为公关策略</a>
					<div>
						北京时间3月12日消息,据&lt;福布斯&gt;杂志网络版报道,两天前,维基解密创始人朱利安·阿桑奇(Julian Assange)承诺,该组织会向谷歌.微软等科技巨头提供更多有关中情局(CIA)黑客 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeP71b.html" rel="bookmark" class="title">大规模请求的Linux服务器如何优化连接数？</a>
					<div>
						默认的Linux服务器文件描述符等打开最大是1024,用 ulimit -a 查看:     [viewuser@~]$ ulimit -a    core file size          (b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z4waz.html" rel="bookmark" class="title">Android零基础入门第31节：几乎不用但要了解的AbsoluteLayout绝对布局</a>
					<div>
						原文:Android零基础入门第31节:几乎不用但要了解的AbsoluteLayout绝对布局 前面几期基本学习了Android开发中常用的四种布局,之所以把AbsoluteLayout放在后面来学习 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Z8ZJM.html" rel="bookmark" class="title">RTLinux&mdash;基于Linux内核的实时操作系统RTLinux</a>
					<div>
						     RTLinux(Real-TimeLinux):是由新墨西哥大学(NMT)开发,是可嵌入系统并支持硬实时特性,部分支持POSIX.1b标准.其内核结构和系统特点是实现了一个小的实时核心,并& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnrJ1M.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;传媒老王&rdquo;称自己是&OpenCurlyDoubleQuote;微博控&rdquo;</a>
					<div>
						很多人认识&quot;传媒老王&quot;是从微博开始的,而对于他的身份,似乎很难简单用几个字来概括.有人称他为媒介专家,也有人说他是资深新闻人.&quot;传媒老王&quot;究竟是谁?有一种说法得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjaQ8M.html" rel="bookmark" class="title">xmemcached发布1&period;3&period;2版本</a>
					<div>
						    Xmemcached是一个开源的java memcached client,具有高性能.更易用.功能完善等优点,距离上次发布1.3.1已经超过两个月,现在正式发布1.3.2这个新版本,主要的改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nDZ0z.html" rel="bookmark" class="title">29个骗子购物网站被曝光 中关村科技商城上榜</a>
					<div>
						本报讯 (记者袁国礼)昨天,海淀区消协 曝光29个骗子购物网站及其电话.这些骗子网站以销售电子产品为主,网站电话多为铁通电话,地址不详,消费者受骗后维权困难. 海淀消协有关人士介绍,近年来,海淀消协已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnBY9M.html" rel="bookmark" class="title">uva 572 - Oil Deposits</a>
					<div>
						点击打开链接 题目意思:给你一块区域里面分布着油田,只要有连着就属于同一个油田,求出该区域有几个油田 解题思路:简单的Bfs 或 dfs 可以搞定 ,注意对走过的进行标记用mark数组. 代码: // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYZEab.html" rel="bookmark" class="title">php能否通过thrift直接执行hadoop命令</a>
					<div>
						问题描述 用php通过thrift访问hadoop,发现只有listStatus,read,mkdir等方法,不能直接执行hadoop命令,如hadoopfs-text/usr/*,有哪位大侠能帮忙指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEBvmz.html" rel="bookmark" class="title">amazon ec2-访问amazon EC2 80端口</a>
					<div>
						问题描述 访问amazon EC2 80端口 我在amazonEC2上配置了一个nginx,也启动了.为啥我这浏览器访问不了呢.ping地址也不通 解决方案 已解决,我没有添加入站规则.					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
